# coding: utf-8

"""
    one_msg_waba_sdk

    [1MSG.IO](https://1msg.io/) is the perfect WhatsApp management tool for your business. With us you get full access to the official Whatsapp API/webhooks.  Every API request must contain an Authorize HTTP header with a token.  This is your channel token, which can be found in your channel project on your profile page. Please do not give the token to anyone or post it publicly.  The authorization token must be added to each request in the GET parameter 'token' and always passed to query string (?token={your_token}). Parameters in GET queries pass query string. Parameters in POST requests — through the JSON-encoded request body.   All 'send' methods (except /sendTemplate) will only work when the dialog session with the user is open. Some of our solutions simplify and avoid such limitations, but we urge you to pay more attention to this detail

    The version of the OpenAPI document: 2.39.0
    Contact: hello@1msg.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, StrictFloat, StrictInt, StrictStr

class ChannelExtendedStatisticsInner(BaseModel):
    """
    ChannelExtendedStatisticsInner
    """
    business_initiated_paid_quantity: Optional[StrictInt] = None
    business_initiated_price: Optional[Union[StrictFloat, StrictInt]] = None
    business_initiated_quantity: Optional[StrictInt] = None
    free_entry_point: Optional[StrictInt] = None
    free_quantity: Optional[StrictInt] = None
    free_tier: Optional[StrictInt] = None
    paid_quantity: Optional[StrictInt] = None
    period_date: Optional[StrictStr] = None
    quantity: Optional[Union[StrictFloat, StrictInt]] = None
    total_price: Optional[Union[StrictFloat, StrictInt]] = None
    user_initiated_paid_quantity: Optional[StrictInt] = None
    user_initiated_price: Optional[Union[StrictFloat, StrictInt]] = None
    user_initiated_quantity: Optional[StrictInt] = None
    __properties = ["business_initiated_paid_quantity", "business_initiated_price", "business_initiated_quantity", "free_entry_point", "free_quantity", "free_tier", "paid_quantity", "period_date", "quantity", "total_price", "user_initiated_paid_quantity", "user_initiated_price", "user_initiated_quantity"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ChannelExtendedStatisticsInner:
        """Create an instance of ChannelExtendedStatisticsInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ChannelExtendedStatisticsInner:
        """Create an instance of ChannelExtendedStatisticsInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ChannelExtendedStatisticsInner.parse_obj(obj)

        _obj = ChannelExtendedStatisticsInner.parse_obj({
            "business_initiated_paid_quantity": obj.get("business_initiated_paid_quantity"),
            "business_initiated_price": obj.get("business_initiated_price"),
            "business_initiated_quantity": obj.get("business_initiated_quantity"),
            "free_entry_point": obj.get("free_entry_point"),
            "free_quantity": obj.get("free_quantity"),
            "free_tier": obj.get("free_tier"),
            "paid_quantity": obj.get("paid_quantity"),
            "period_date": obj.get("period_date"),
            "quantity": obj.get("quantity"),
            "total_price": obj.get("total_price"),
            "user_initiated_paid_quantity": obj.get("user_initiated_paid_quantity"),
            "user_initiated_price": obj.get("user_initiated_price"),
            "user_initiated_quantity": obj.get("user_initiated_quantity")
        })
        return _obj


