# coding: utf-8

"""
    one_msg_waba_sdk

    [1MSG.IO](https://1msg.io/) is the perfect WhatsApp management tool for your business. With us you get full access to the official Whatsapp API/webhooks.  Every API request must contain an Authorize HTTP header with a token.  This is your channel token, which can be found in your channel project on your profile page. Please do not give the token to anyone or post it publicly.  The authorization token must be added to each request in the GET parameter 'token' and always passed to query string (?token={your_token}). Parameters in GET queries pass query string. Parameters in POST requests — through the JSON-encoded request body.   All 'send' methods (except /sendTemplate) will only work when the dialog session with the user is open. Some of our solutions simplify and avoid such limitations, but we urge you to pay more attention to this detail

    The version of the OpenAPI document: 2.39.0
    Contact: hello@1msg.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, validator

class Message(BaseModel):
    """
    Message
    """
    id: Optional[StrictStr] = Field(None, description="unique id")
    body: Optional[StrictStr] = Field(None, description="text message for type \"chat\", or link to download the file for \"ptt\", \"image\", \"audio\", \"video\" and \"document\", or latitude and longitude for \"location\", or message \"[Call]\" for \"call_log\"")
    from_me: Optional[StrictBool] = Field(None, alias="fromMe", description="true - outgoing, false - incoming")
    var_self: Optional[StrictInt] = Field(None, alias="self", description="1 - generated by api, 0 - generated by app")
    is_forwarded: Optional[StrictBool] = Field(None, alias="isForwarded", description="true - forwarded message, false - direct message")
    author: Optional[StrictStr] = Field(None, description="Author ID of the message")
    time: Optional[StrictInt] = Field(None, description="send time, unix timestamp")
    chat_id: Optional[StrictStr] = Field(None, alias="chatId", description="chat ID")
    type: Optional[StrictStr] = Field(None, description="type of the message")
    sender_name: Optional[StrictStr] = Field(None, alias="senderName", description="Sender name")
    caption: Optional[StrictStr] = Field(None, description="File caption or filename")
    quoted_msg_id: Optional[StrictStr] = Field(None, alias="quotedMsgId", description="ID of quoted message")
    __properties = ["id", "body", "fromMe", "self", "isForwarded", "author", "time", "chatId", "type", "senderName", "caption", "quotedMsgId"]

    @validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('chat', 'interactive', 'image', 'video', 'document', 'audio', 'sticker', 'voice'):
            raise ValueError("must be one of enum values ('chat', 'interactive', 'image', 'video', 'document', 'audio', 'sticker', 'voice')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Message:
        """Create an instance of Message from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Message:
        """Create an instance of Message from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Message.parse_obj(obj)

        _obj = Message.parse_obj({
            "id": obj.get("id"),
            "body": obj.get("body"),
            "from_me": obj.get("fromMe"),
            "var_self": obj.get("self"),
            "is_forwarded": obj.get("isForwarded"),
            "author": obj.get("author"),
            "time": obj.get("time"),
            "chat_id": obj.get("chatId"),
            "type": obj.get("type"),
            "sender_name": obj.get("senderName"),
            "caption": obj.get("caption"),
            "quoted_msg_id": obj.get("quotedMsgId")
        })
        return _obj


