# coding: utf-8

"""
    one_msg_waba_sdk

    [1MSG.IO](https://1msg.io/) is the perfect WhatsApp management tool for your business. With us you get full access to the official Whatsapp API/webhooks.  Every API request must contain an Authorize HTTP header with a token.  This is your channel token, which can be found in your channel project on your profile page. Please do not give the token to anyone or post it publicly.  The authorization token must be added to each request in the GET parameter 'token' and always passed to query string (?token={your_token}). Parameters in GET queries pass query string. Parameters in POST requests — through the JSON-encoded request body.   All 'send' methods (except /sendTemplate) will only work when the dialog session with the user is open. Some of our solutions simplify and avoid such limitations, but we urge you to pay more attention to this detail

    The version of the OpenAPI document: 2.39.0
    Contact: hello@1msg.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr

class SendLocationRequest(BaseModel):
    """
    SendLocationRequest
    """
    chat_id: Optional[StrictStr] = Field(None, alias="chatId", description="**Required if phone is not set**  Chat ID from the message list. Examples: 12020721369@c.us . Used instead of the phone parameter.")
    phone: Optional[StrictInt] = Field(None, description="**Required if chatId is not set**  A phone number starting with the country code. You do not need to add your number.   USA example: 12020721369.")
    lat: StrictStr = Field(..., description="Latitude of the location. Example: 45.018337")
    lng: StrictStr = Field(..., description="Longitude of the location. Example: -73.968285")
    address: Optional[StrictStr] = Field(None, description="Address of the location. Only displayed if name is present. Example: 9766 Valley View St., New York, NY 10024")
    name: Optional[StrictStr] = Field(None, description="Name of the location. Example: Facebook HQ")
    __properties = ["chatId", "phone", "lat", "lng", "address", "name"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SendLocationRequest:
        """Create an instance of SendLocationRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SendLocationRequest:
        """Create an instance of SendLocationRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SendLocationRequest.parse_obj(obj)

        _obj = SendLocationRequest.parse_obj({
            "chat_id": obj.get("chatId"),
            "phone": obj.get("phone"),
            "lat": obj.get("lat"),
            "lng": obj.get("lng"),
            "address": obj.get("address"),
            "name": obj.get("name")
        })
        return _obj


